diff -ruN vdr-2.3.4/filter.c vdr-2.3.5/filter.c
--- vdr-2.3.4/filter.c	2015-07-25 12:59:57.000000000 +0200
+++ vdr-2.3.5/filter.c	2017-05-07 17:20:45.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: filter.c 4.2 2015/07/25 10:59:57 kls Exp $
+ * $Id: filter.c 4.3 2017/05/07 15:20:45 kls Exp $
  */
 
 #include "filter.h"
@@ -71,6 +71,15 @@
   sticky = Sticky;
 }
 
+cFilterData& cFilterData::operator= (const cFilterData &FilterData)
+{
+  pid = FilterData.pid;
+  tid = FilterData.tid;
+  mask = FilterData.mask;
+  sticky = FilterData.sticky;
+  return *this;
+}
+
 bool cFilterData::Is(u_short Pid, u_char Tid, u_char Mask)
 {
   return pid == Pid && tid == Tid && mask == Mask;
diff -ruN vdr-2.3.4/filter.h vdr-2.3.5/filter.h
--- vdr-2.3.4/filter.h	2015-07-25 12:03:44.000000000 +0200
+++ vdr-2.3.5/filter.h	2017-05-07 17:18:48.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: filter.h 4.2 2015/07/25 10:03:44 kls Exp $
+ * $Id: filter.h 4.3 2017/05/07 15:18:48 kls Exp $
  */
 
 #ifndef __FILTER_H
@@ -38,6 +38,7 @@
   bool sticky;
   cFilterData(void);
   cFilterData(u_short Pid, u_char Tid, u_char Mask, bool Sticky);
+  cFilterData& operator= (const cFilterData &FilterData);
   bool Is(u_short Pid, u_char Tid, u_char Mask);
   bool Matches(u_short Pid, u_char Tid);
   };
diff -ruN vdr-2.3.4/libsi/Makefile vdr-2.3.5/libsi/Makefile
--- vdr-2.3.4/libsi/Makefile	2015-02-11 11:24:54.000000000 +0100
+++ vdr-2.3.5/libsi/Makefile	2017-05-22 17:33:20.000000000 +0200
@@ -1,7 +1,7 @@
 #
 # Makefile for a libsi
 #
-# $Id: Makefile 4.0 2015/02/11 10:24:54 kls Exp $
+# $Id: Makefile 4.1 2017/05/22 15:33:20 kls Exp $
 
 ### The archiver options:
 
@@ -18,7 +18,8 @@
 ### Implicit rules:
 
 %.o: %.c
-	$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+	@echo CC libsi/$@
+	@$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
 
 ### Dependencies:
 
@@ -35,7 +36,8 @@
 	@:
 
 libsi.a : $(OBJS)
-	$(AR) $(ARFLAGS) $@ $(OBJS)
+	@echo AR libsi/$@
+	@$(AR) $(ARFLAGS) $@ $(OBJS)
 
 clean:
 	@-rm -f $(OBJS) $(DEPFILE) *.a *.so *.tgz core* *~
diff -ruN vdr-2.3.4/menu.c vdr-2.3.5/menu.c
--- vdr-2.3.4/menu.c	2017-04-20 11:15:49.000000000 +0200
+++ vdr-2.3.5/menu.c	2017-05-21 15:18:26.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 4.25 2017/04/20 09:15:49 kls Exp $
+ * $Id: menu.c 4.29 2017/05/21 13:18:26 kls Exp $
  */
 
 #include "menu.h"
@@ -1328,7 +1328,7 @@
   if (HasSubMenu())
      return osContinue;
   cTimer *Timer = new cTimer;
-  if (*Setup.SVDRPDefaultHost)
+  if (Setup.SVDRPPeering && *Setup.SVDRPDefaultHost)
      Timer->SetRemote(Setup.SVDRPDefaultHost);
   return AddSubMenu(new cMenuEditTimer(Timer, true));
 }
@@ -1660,7 +1660,7 @@
              return AddSubMenu(new cMenuEditTimer(Timer));
           }
        cTimer *Timer = new cTimer(item->event);
-       if (*Setup.SVDRPDefaultHost)
+       if (Setup.SVDRPPeering && *Setup.SVDRPDefaultHost)
           Timer->SetRemote(Setup.SVDRPDefaultHost);
        if (cTimer *t = Timers->GetTimer(Timer)) {
           delete Timer;
@@ -1674,7 +1674,6 @@
        if (!HandleRemoteModifications(Timer)) {
           // must add the timer before HandleRemoteModifications to get proper log messages with timer ids
           Timers->Del(Timer);
-          delete Timer;
           }
      }
      if (HasSubMenu())
@@ -1692,7 +1691,7 @@
   eOSState state = cOsdMenu::ProcessKey(Key);
 
   if (state == osUnknown) {
-     switch (Key) {
+     switch (int(Key)) {
        case kRecord:
        case kRed:    return Record();
        case kYellow: state = osBack;
@@ -1708,6 +1707,20 @@
        case kBlue:   if (canSwitch)
                         return Switch();
                      break;
+       case kChanUp|k_Repeat:
+       case kChanUp:
+       case kChanDn|k_Repeat:
+       case kChanDn: if (!HasSubMenu()) {
+                        for (cOsdItem *item = First(); item; item = Next(item)) {
+                            if (((cMenuScheduleItem *)item)->channel->Number() == cDevice::CurrentChannel()) {
+                               SetCurrent(item);
+                               Display();
+                               SetHelpKeys();
+                               break;
+                               }
+                            }
+                        }
+                     break;
        case kInfo:
        case kOk:     if (Count()) {
                         LOCK_TIMERS_READ;
@@ -1944,7 +1957,7 @@
              return AddSubMenu(new cMenuEditTimer(Timer));
           }
        cTimer *Timer = new cTimer(item->event);
-       if (*Setup.SVDRPDefaultHost)
+       if (Setup.SVDRPPeering && *Setup.SVDRPDefaultHost)
           Timer->SetRemote(Setup.SVDRPDefaultHost);
        if (cTimer *t = Timers->GetTimer(Timer)) {
           delete Timer;
@@ -1958,7 +1971,6 @@
        if (!HandleRemoteModifications(Timer)) {
           // must add the timer before HandleRemoteModifications to get proper log messages with timer ids
           Timers->Del(Timer);
-          delete Timer;
           }
      }
      if (HasSubMenu())
@@ -1995,7 +2007,7 @@
   eOSState state = cOsdMenu::ProcessKey(Key);
 
   if (state == osUnknown) {
-     switch (Key) {
+     switch (int(Key)) {
        case k0:      return Number();
        case kRecord:
        case kRed:    return Record();
@@ -2025,6 +2037,15 @@
        case kBlue:   if (canSwitch)
                         return Switch();
                      break;
+       case kChanUp|k_Repeat:
+       case kChanUp:
+       case kChanDn|k_Repeat:
+       case kChanDn: if (!HasSubMenu()) {
+                        LOCK_CHANNELS_READ;
+                        if (const cChannel *Channel = Channels->GetByNumber(cDevice::CurrentChannel()))
+                           Set(Channel, true);
+                        }
+                     break;
        case kInfo:
        case kOk:     if (Count()) {
                         LOCK_TIMERS_READ;
@@ -2243,7 +2264,7 @@
      SetHasHotkeys(ciMenu->Selectable());
      GenerateTitle(ciMenu->TitleText());
      dsyslog("CAM %d: '%s'", camSlot->SlotNumber(), ciMenu->TitleText());
-     if (*ciMenu->SubTitleText()) {
+     if (!isempty(ciMenu->SubTitleText())) {
         dsyslog("CAM %d: '%s'", camSlot->SlotNumber(), ciMenu->SubTitleText());
         AddMultiLineItem(ciMenu->SubTitleText());
         offset = Count();
@@ -2252,7 +2273,7 @@
          Add(new cOsdItem(hk(ciMenu->Entry(i)), osUnknown, ciMenu->Selectable()));
          dsyslog("CAM %d: '%s'", camSlot->SlotNumber(), ciMenu->Entry(i));
          }
-     if (*ciMenu->BottomText()) {
+     if (!isempty(ciMenu->BottomText())) {
         AddMultiLineItem(ciMenu->BottomText());
         dsyslog("CAM %d: '%s'", camSlot->SlotNumber(), ciMenu->BottomText());
         }
@@ -5185,7 +5206,7 @@
      int Priority = Timer ? Timer->Priority() : Pause ? Setup.PausePriority : Setup.DefaultPriority;
      cDevice *device = cDevice::GetDevice(Channel, Priority, false);
      if (device) {
-        dsyslog("switching device %d to channel %d (%s)", device->DeviceNumber() + 1, Channel->Number(), Channel->Name());
+        dsyslog("switching device %d to channel %d %s (%s)", device->DeviceNumber() + 1, Channel->Number(), *Channel->GetChannelID().ToString(), Channel->Name());
         if (!device->SwitchChannel(Channel, false)) {
            ShutdownHandler.RequestEmergencyExit();
            return false;
diff -ruN vdr-2.3.4/mtd.c vdr-2.3.5/mtd.c
--- vdr-2.3.4/mtd.c	2017-04-26 10:33:54.000000000 +0200
+++ vdr-2.3.5/mtd.c	2017-05-01 11:19:52.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: mtd.c 1.10 2017/04/26 08:33:54 kls Exp $
+ * $Id: mtd.c 1.11 2017/05/01 09:19:52 kls Exp $
  */
 
 #include "mtd.h"
@@ -64,22 +64,20 @@
         if (int Skipped = TS_SYNC(Data, Count))
            return Used + Skipped;
         int Pid = TsPid(Data);
-        if (Pid != CATPID) { // the original CAT with mapped PIDs must be skipped here!
 #ifdef KEEPPIDS
-           int Index = 0;
+        int Index = 0;
 #else
-           int Index = (Pid >> UNIQ_PID_SHIFT) - 1;
+        int Index = (Pid >> UNIQ_PID_SHIFT) - 1;
 #endif // KEEPPIDS
-           if (Index >= 0 && Index < camSlots.Size()) {
-              int w = camSlots[Index]->PutData(Data, TS_SIZE);
-              if (w == 0)
-                 break;
-              else if (w != TS_SIZE)
-                 esyslog("ERROR: incomplete MTD packet written (%d) in PID %d (%04X)", Index + 1, Pid, Pid);
-              }
-           else if (Index >= 0) // we silently ignore Index -1 (i.e. MTD number 0), since there are several hundred empty TS packets when switching to an encrypted channel for the first time since startup
-              esyslog("ERROR: invalid MTD number (%d) in PID %d (%04X)", Index + 1, Pid, Pid);
+        if (Index >= 0 && Index < camSlots.Size()) {
+           int w = camSlots[Index]->PutData(Data, TS_SIZE);
+           if (w == 0)
+              break;
+           else if (w != TS_SIZE)
+              esyslog("ERROR: incomplete MTD packet written (%d) in PID %d (%04X)", Index + 1, Pid, Pid);
            }
+        else if (Index >= 0) // anything with Index -1 (i.e. MTD number 0) is either garbage or an actual CAT or EIT, which need not be returned to the device
+           esyslog("ERROR: invalid MTD number (%d) in PID %d (%04X)", Index + 1, Pid, Pid);
         Data += TS_SIZE;
         Count -= TS_SIZE;
         Used += TS_SIZE;
@@ -329,6 +327,11 @@
   return d;
 }
 
+void cMtdCamSlot::InjectEit(int Sid)
+{
+  MasterSlot()->InjectEit(mtdMapper->RealToUniqSid(Sid));
+}
+
 int cMtdCamSlot::PutData(const uchar *Data, int Count)
 {
   int Free = mtdBuffer->Free();
diff -ruN vdr-2.3.4/mtd.h vdr-2.3.5/mtd.h
--- vdr-2.3.4/mtd.h	2017-04-26 11:17:08.000000000 +0200
+++ vdr-2.3.5/mtd.h	2017-05-01 11:19:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: mtd.h 1.7 2017/04/26 09:17:08 kls Exp $
+ * $Id: mtd.h 1.8 2017/05/01 09:19:21 kls Exp $
  */
 
 #ifndef __MTD_H
@@ -172,6 +172,7 @@
   virtual void StartDecrypting(void);
   virtual void StopDecrypting(void);
   virtual uchar *Decrypt(uchar *Data, int &Count);
+  virtual void InjectEit(int Sid);
   int PutData(const uchar *Data, int Count);
   int PutCat(const uchar *Data, int Count);
   // The following functions shall not be called for a cMtdCamSlot:
diff -ruN vdr-2.3.4/newplugin vdr-2.3.5/newplugin
--- vdr-2.3.4/newplugin	2015-09-10 13:11:14.000000000 +0200
+++ vdr-2.3.5/newplugin	2017-05-22 17:34:01.000000000 +0200
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 4.1 2015/09/10 11:11:14 kls Exp $
+# $Id: newplugin 4.2 2017/05/22 15:34:01 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -121,7 +121,8 @@
 ### Implicit rules:
 
 %.o: %.c
-	\$(CXX) \$(CXXFLAGS) -c \$(DEFINES) \$(INCLUDES) -o \$\@ \$<
+	\@echo CC \$\@
+	\@\$(CXX) \$(CXXFLAGS) -c \$(DEFINES) \$(INCLUDES) -o \$\@ \$<
 
 ### Dependencies:
 
@@ -141,13 +142,16 @@
 I18Npot   = \$(PODIR)/\$(PLUGIN).pot
 
 %.mo: %.po
-	msgfmt -c -o \$\@ \$<
+	\@echo MO \$\@
+	\@msgfmt -c -o \$\@ \$<
 
 \$(I18Npot): \$(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-\$(PLUGIN) --package-version=\$(VERSION) --msgid-bugs-address='<see README>' -o \$\@ `ls \$^`
+	\@echo GT \$\@
+	\@xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=vdr-\$(PLUGIN) --package-version=\$(VERSION) --msgid-bugs-address='<see README>' -o \$\@ `ls \$^`
 
 %.po: \$(I18Npot)
-	msgmerge -U --no-wrap --no-location --backup=none -q -N \$\@ \$<
+	\@echo PO \$\@
+	\@msgmerge -U --no-wrap --no-location --backup=none -q -N \$\@ \$<
 	\@touch \$\@
 
 \$(I18Nmsgs): \$(DESTDIR)\$(LOCDIR)/%/LC_MESSAGES/vdr-\$(PLUGIN).mo: \$(PODIR)/%.mo
@@ -161,7 +165,8 @@
 ### Targets:
 
 \$(SOFILE): \$(OBJS)
-	\$(CXX) \$(CXXFLAGS) \$(LDFLAGS) -shared \$(OBJS) -o \$\@
+	\@echo LD \$\@
+	\@\$(CXX) \$(CXXFLAGS) \$(LDFLAGS) -shared \$(OBJS) -o \$\@
 
 install-lib: \$(SOFILE)
 	install -D \$^ \$(DESTDIR)\$(LIBDIR)/\$^.\$(APIVERSION)
diff -ruN vdr-2.3.4/receiver.c vdr-2.3.5/receiver.c
--- vdr-2.3.4/receiver.c	2017-04-01 17:55:38.000000000 +0200
+++ vdr-2.3.5/receiver.c	2017-05-01 10:49:20.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 4.3 2017/04/01 15:55:38 kls Exp $
+ * $Id: receiver.c 4.4 2017/05/01 08:49:20 kls Exp $
  */
 
 #include "receiver.h"
@@ -19,6 +19,8 @@
   lastScrambledPacket = 0;
   startScrambleDetection = 0;
   scramblingTimeout = 0;
+  startEitInjection = 0;
+  lastEitInjection = 0;
   SetPids(Channel);
 }
 
diff -ruN vdr-2.3.4/receiver.h vdr-2.3.5/receiver.h
--- vdr-2.3.4/receiver.h	2017-04-01 17:55:27.000000000 +0200
+++ vdr-2.3.5/receiver.h	2017-05-01 10:48:34.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.h 4.2 2017/04/01 15:55:27 kls Exp $
+ * $Id: receiver.h 4.3 2017/05/01 08:48:34 kls Exp $
  */
 
 #ifndef __RECEIVER_H
@@ -25,6 +25,8 @@
   time_t lastScrambledPacket;
   time_t startScrambleDetection;
   int scramblingTimeout;
+  time_t startEitInjection;
+  time_t lastEitInjection;
   bool WantsPid(int Pid);
 protected:
   cDevice *Device(void) { return device; }
diff -ruN vdr-2.3.4/remux.c vdr-2.3.5/remux.c
--- vdr-2.3.4/remux.c	2017-04-24 16:59:39.000000000 +0200
+++ vdr-2.3.5/remux.c	2017-04-29 14:25:09.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 4.6 2017/04/24 14:59:39 kls Exp $
+ * $Id: remux.c 4.7 2017/04/29 12:25:09 kls Exp $
  */
 
 #include "remux.h"
@@ -940,6 +940,93 @@
   return patVersion >= 0 && pmtVersion >= 0;
 }
 
+// --- cEitGenerator ---------------------------------------------------------
+
+cEitGenerator::cEitGenerator(int Sid)
+{
+  counter = 0;
+  version = 0;
+  if (Sid)
+     Generate(Sid);
+}
+
+uint16_t cEitGenerator::YMDtoMJD(int Y, int M, int D)
+{
+  int L = (M < 3) ? 1 : 0;
+  return 14956 + D + int((Y - L) * 365.25) + int((M + 1 + L * 12) * 30.6001);
+}
+
+uchar *cEitGenerator::AddParentalRatingDescriptor(uchar *p, uchar ParentalRating)
+{
+  *p++ = SI::ParentalRatingDescriptorTag;
+  *p++ = 0x04; // descriptor length
+  *p++ = 'D';  // country code
+  *p++ = 'E';
+  *p++ = 'U';
+  *p++ = ParentalRating;
+  return p;
+}
+
+uchar *cEitGenerator::Generate(int Sid)
+{
+  uchar *PayloadStart;
+  uchar *SectionStart;
+  uchar *DescriptorsStart;
+  memset(eit, 0xFF, sizeof(eit));
+  struct tm tm_r;
+  time_t t = time(NULL) - 3600; // let's have the event start one hour in the past
+  tm *tm = localtime_r(&t, &tm_r);
+  uint16_t MJD = YMDtoMJD(tm->tm_year, tm->tm_mon + 1, tm->tm_mday);
+  uchar *p = eit;
+  // TS header:
+  *p++ = TS_SYNC_BYTE;
+  *p++ = TS_PAYLOAD_START;
+  *p++ = EITPID;
+  *p++ = 0x10 | (counter++ & 0x0F); // continuity counter
+  *p++ = 0x00; // pointer field (payload unit start indicator is set)
+  // payload:
+  PayloadStart = p;
+  *p++ = 0x4E; // TID present/following event on this transponder
+  *p++ = 0xF0;
+  *p++ = 0x00; // section length
+  SectionStart = p;
+  *p++ = Sid >> 8;
+  *p++ = Sid & 0xFF;
+  *p++ = 0xC1 | (version << 1);
+  *p++ = 0x00; // section number
+  *p++ = 0x00; // last section number
+  *p++ = 0x00; // transport stream id
+  *p++ = 0x00; // ...
+  *p++ = 0x00; // original network id
+  *p++ = 0x00; // ...
+  *p++ = 0x00; // segment last section number
+  *p++ = 0x4E; // last table id
+  *p++ = 0x00; // event id
+  *p++ = 0x01; // ...
+  *p++ = MJD >> 8; // start time
+  *p++ = MJD & 0xFF;  // ...
+  *p++ = tm->tm_hour; // ...
+  *p++ = tm->tm_min;  // ...
+  *p++ = tm->tm_sec;  // ...
+  *p++ = 0x24; // duration (one day, should cover everything)
+  *p++ = 0x00; // ...
+  *p++ = 0x00; // ...
+  *p++ = 0x90; // running status, free/CA mode
+  *p++ = 0x00; // descriptors loop length
+  DescriptorsStart = p;
+  p = AddParentalRatingDescriptor(p);
+  // fill in lengths:
+  *(SectionStart - 1) = p - SectionStart + 4; // +4 = length of CRC
+  *(DescriptorsStart - 1) = p - DescriptorsStart;
+  // checksum
+  int crc = SI::CRC32::crc32((char *)PayloadStart, p - PayloadStart, 0xFFFFFFFF);
+  *p++ = crc >> 24;
+  *p++ = crc >> 16;
+  *p++ = crc >> 8;
+  *p++ = crc;
+  return eit;
+}
+
 // --- cTsToPes --------------------------------------------------------------
 
 cTsToPes::cTsToPes(void)
diff -ruN vdr-2.3.4/remux.h vdr-2.3.5/remux.h
--- vdr-2.3.4/remux.h	2017-03-26 15:06:37.000000000 +0200
+++ vdr-2.3.5/remux.h	2017-05-21 11:44:52.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 4.3 2017/03/26 13:06:37 kls Exp $
+ * $Id: remux.h 4.5 2017/05/21 09:44:52 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -51,6 +51,7 @@
 
 #define PATPID 0x0000 // PAT PID (constant 0)
 #define CATPID 0x0001 // CAT PID (constant 1)
+#define EITPID 0x0012 // EIT PID (constant 18)
 #define MAXPID 0x2000 // for arrays that use a PID as the index
 
 #define PTSTICKS  90000 // number of PTS ticks per second
@@ -94,7 +95,7 @@
   return p[3] & TS_SCRAMBLING_CONTROL;
 }
 
-inline uchar TsGetContinuityCounter(const uchar *p)
+inline uchar TsContinuityCounter(const uchar *p)
 {
   return p[3] & TS_CONT_CNT_MASK;
 }
@@ -120,11 +121,6 @@
   return 0;
 }
 
-inline int TsContinuityCounter(const uchar *p)
-{
-  return p[3] & TS_CONT_CNT_MASK;
-}
-
 inline int64_t TsGetPcr(const uchar *p)
 {
   if (TsHasAdaptationField(p)) {
@@ -431,6 +427,22 @@
   uint16_t AncillaryPageId(int i) const { return (0 <= i && i < MAXSPIDS) ? ancillaryPageIds[i] : uint16_t(0); }
   };
 
+// EIT Generator:
+
+class cEitGenerator {
+private:
+  uchar eit[TS_SIZE];
+  int counter;
+  int version;
+  uint16_t YMDtoMJD(int Y, int M, int D);
+  uchar *AddParentalRatingDescriptor(uchar *p, uchar ParentalRating = 0);
+public:
+  cEitGenerator(int Sid = 0);
+  uchar *Generate(int Sid);
+  uchar *Data(void) { return eit; }
+  int Length(void) { return sizeof(eit); }
+  };
+
 // TS to PES converter:
 // Puts together the payload of several TS packets that form one PES
 // packet.
diff -ruN vdr-2.3.4/svdrp.c vdr-2.3.5/svdrp.c
--- vdr-2.3.4/svdrp.c	2017-04-22 13:57:31.000000000 +0200
+++ vdr-2.3.5/svdrp.c	2017-05-18 17:51:24.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 4.17 2017/04/22 11:57:31 kls Exp $
+ * $Id: svdrp.c 4.18 2017/05/18 15:51:24 kls Exp $
  */
 
 #include "svdrp.h"
@@ -384,6 +384,8 @@
      SVDRPClientPoller.Del(file, false);
      file.Close();
      socket.Close();
+     LOCK_TIMERS_WRITE;
+     Timers->DelRemoteTimers(serverName);
      }
 }
 
diff -ruN vdr-2.3.4/tools.c vdr-2.3.5/tools.c
--- vdr-2.3.4/tools.c	2016-12-23 15:03:40.000000000 +0100
+++ vdr-2.3.5/tools.c	2017-05-09 10:32:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 4.5 2016/12/23 14:03:40 kls Exp $
+ * $Id: tools.c 4.6 2017/05/09 08:32:54 kls Exp $
  */
 
 #include "tools.h"
@@ -2312,9 +2312,10 @@
 
 // --- cHashBase -------------------------------------------------------------
 
-cHashBase::cHashBase(int Size)
+cHashBase::cHashBase(int Size, bool OwnObjects)
 {
   size = Size;
+  ownObjects = OwnObjects;
   hashTable = (cList<cHashObject>**)calloc(size, sizeof(cList<cHashObject>*));
 }
 
@@ -2348,6 +2349,13 @@
 void cHashBase::Clear(void)
 {
   for (int i = 0; i < size; i++) {
+      if (ownObjects) {
+         cList<cHashObject> *list = hashTable[i];
+         if (list) {
+            for (cHashObject *hob = list->First(); hob; hob = list->Next(hob))
+                delete hob->object;
+            }
+         }
       delete hashTable[i];
       hashTable[i] = NULL;
       }
diff -ruN vdr-2.3.4/tools.h vdr-2.3.5/tools.h
--- vdr-2.3.4/tools.h	2017-03-16 17:04:43.000000000 +0100
+++ vdr-2.3.5/tools.h	2017-05-22 13:07:04.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 4.6 2017/03/16 16:04:43 kls Exp $
+ * $Id: tools.h 4.10 2017/05/22 11:07:04 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -51,10 +51,14 @@
 #define CHECK(s) { if ((s) < 0) LOG_ERROR; } // used for 'ioctl()' calls
 #define FATALERRNO (errno && errno != EAGAIN && errno != EINTR)
 
-#ifndef __STL_CONFIG_H // in case some plugin needs to use the STL
+#ifndef _STL_ALGOBASE_H // in case some plugin needs to use the STL
 template<class T> inline T min(T a, T b) { return a <= b ? a : b; }
 template<class T> inline T max(T a, T b) { return a >= b ? a : b; }
+#endif
+#ifndef __STL_CONFIG_H // in case some plugin needs to use the STL
 template<class T> inline int sgn(T a) { return a < 0 ? -1 : a > 0 ? 1 : 0; }
+#endif
+#ifndef _MOVE_H // in case some plugin needs to use the STL
 template<class T> inline void swap(T &a, T &b) { T t = a; a = b; b = t; }
 #endif
 
@@ -479,6 +483,8 @@
   friend class cListGarbageCollector;
 private:
   cListObject *prev, *next;
+  cListObject(const cListObject &ListObject) { abort(); } // no copy constructor!
+  cListObject& operator= (const cListObject &ListObject) { abort(); return *this; } // no assignment operator!
 public:
   cListObject(void);
   virtual ~cListObject();
@@ -825,9 +831,14 @@
 private:
   cList<cHashObject> **hashTable;
   int size;
+  bool ownObjects;
   unsigned int hashfn(unsigned int Id) const { return Id % size; }
 protected:
-  cHashBase(int Size);
+  cHashBase(int Size, bool OwnObjects);
+       ///< Creates a new hash of the given Size. If OwnObjects is true, the
+       ///< hash takes ownership of the objects given in the calls to Add(),
+       ///< and deletes them when Clear() is called or the hash is destroyed
+       ///< (unless the object has been removed from the hash by calling Del()).
 public:
   virtual ~cHashBase();
   void Add(cListObject *Object, unsigned int Id);
@@ -841,7 +852,7 @@
 
 template<class T> class cHash : public cHashBase {
 public:
-  cHash(int Size = HASHSIZE) : cHashBase(Size) {}
+  cHash(int Size = HASHSIZE, bool OwnObjects = false) : cHashBase(Size, OwnObjects) {}
   T *Get(unsigned int Id) const { return (T *)cHashBase::Get(Id); }
 };
 
diff -ruN vdr-2.3.4/vdr.c vdr-2.3.5/vdr.c
--- vdr-2.3.4/vdr.c	2017-04-03 14:35:37.000000000 +0200
+++ vdr-2.3.5/vdr.c	2017-05-21 14:31:37.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 4.12 2017/04/03 12:35:37 kls Exp $
+ * $Id: vdr.c 4.14 2017/05/21 12:31:37 kls Exp $
  */
 
 #include <getopt.h>
@@ -1151,7 +1151,7 @@
                        if (!Device->IsTunedToTransponder(Timer->Channel())) {
                           if (Device == cDevice::ActualDevice() && !Device->IsPrimaryDevice())
                              cDevice::PrimaryDevice()->StopReplay(); // stop transfer mode
-                          dsyslog("switching device %d to channel %d (%s)", Device->DeviceNumber() + 1, Timer->Channel()->Number(), Timer->Channel()->Name());
+                          dsyslog("switching device %d to channel %d %s (%s)", Device->DeviceNumber() + 1, Timer->Channel()->Number(), *Timer->Channel()->GetChannelID().ToString(), Timer->Channel()->Name());
                           if (Device->SwitchChannel(Timer->Channel(), false))
                              Device->SetOccupied(TIMERDEVICETIMEOUT);
                           }
@@ -1282,7 +1282,6 @@
                   }
                else
                   cDevice::SwitchChannel(NORMALKEY(key) == kChanUp ? 1 : -1);
-               key = kNone; // nobody else needs to see these keys
                break;
           // Volume control:
           case kVolUp|k_Repeat:
